
.include "vcs.inc"
.include "globals.inc"

.segment "ZEROPAGE"
errortablea:
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
errortablex:
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
errortablei:
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00
   .byte $00,$00,$00,$00,$00,$00,$00,$00

showbuf: .byte $00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00
tmp    : .byte $00

result : .byte 0
zpcode : .byte 0,0,0,0,0
aval   : .byte 0
xval   : .byte 0
ival = zpcode + 1

colidx : .byte 0

.segment "RODATA"
bittable:
   .byte $80,$40,$20,$10,$08,$04,$02,$01
   
.segment "CODE"

reset:
   sei
   cld
   lda #$00
   tax
@loop:
   pha
   txs
   inx
   bne @loop

   lda #$3f
   sta PF1
   lda #$03
   sta PF2
   
   lda #$02
   sta CTRLPF

   lda #$00
   ldx #$ff
   .byte $8b, $ff
   sta showbuf+0

   jsr fastcheck
   sta showbuf + 5
   
   lda #0
   sta aval
   sta xval
;   lda #$ff ; uncomment this for a quick run
   sta ival

   lda #$8b
   sta zpcode
   lda #$4c
   sta zpcode+2
   lda #<rethere
   sta zpcode+3
   lda #>rethere
   sta zpcode+4

loop:
   lda aval
   sta COLUP0
   ldx xval
   jmp zpcode
rethere:
   sta result

   lda aval
   ora showbuf+0
   and xval
   and ival
   ;cmp result
   eor result
   bne wrong

continue:
   inc aval
   bne loop
   inc xval
   bne loop
   inc ival
   lda ival
   sta COLUP1
   bne loop

   jmp loop_end
   
wrong:
   ora showbuf+4
   sta showbuf+4 
   inc showbuf+1
   bne noc
   inc showbuf+2
   bne noc
   inc showbuf+3
noc:
   lda aval
   lsr
   lsr
   lsr
   tay
   lda aval
   and #$07
   tax
   lda bittable,x
   ora errortablea,y
   sta errortablea,y

   lda xval
   lsr
   lsr
   lsr
   tay
   lda xval
   and #$07
   tax
   lda bittable,x
   ora errortablex,y
   sta errortablex,y

   lda ival
   lsr
   lsr
   lsr
   tay
   lda ival
   and #$07
   tax
   lda bittable,x
   ora errortablei,y
   sta errortablei,y

   inc colidx
   lda colidx
   sta COLUBK
   clc
   bcc continue   

loop_end:
   lda #$00
   sta PF0
   sta PF1
   sta PF2
   sta CTRLPF
   
   lda #$2e
   sta COLUP0
   sta COLUP1
   sta COLUPF

vblankstart:
   lda #$02
   sta WSYNC
   sta VBLANK
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta VSYNC
   sta WSYNC
   sta WSYNC
   lda #$29
   sta TIM64T
   lda #$00
   sta WSYNC
   sta COLUBK
   sta VSYNC
   
waitforpicturestart:
   lda #$2f
   sta TIM64T
   
; do the fancy stuff here   
   
@wait:
   lda INTIM
   bne @wait
   sta VBLANK

   lda SWCHA
   and #$f0
   cmp #$f0
   beq nojoy
   cmp #$70 ; right
   bne noright
   lda #'x'
   sta aval
   
noright:
   cmp #$b0 ; left
   bne noleft
   lda #'a'
   sta aval

noleft:
   cmp #$d0 ; down
   bne nodown
   lda #'i'
   sta aval
   
nodown:
   cmp #$e0 ; up
   bne nojoy
   lda #$00
   sta aval
   
nojoy:
   lda aval
   bne nostatus
   sta WSYNC
   ldx #$07
@loop2:
   dex
   bne @loop2
   lda #$00
   sta NUSIZ0
   sta NUSIZ1
   sta RESP0
   sta RESP1
   
   lda showbuf+0
   jsr hextosprites
   lda showbuf+1
   jsr hextosprites
   lda showbuf+2
   jsr hextosprites
   lda showbuf+3
   jsr hextosprites
   lda showbuf+4
   jsr hextosprites
   lda showbuf+5
   jsr hextosprites
   lda showbuf+6
   jsr hextosprites
   lda showbuf+7
   jsr hextosprites
   lda showbuf+8
   jsr hextosprites
   lda showbuf+9
   jsr hextosprites
   lda showbuf+10
   jsr hextosprites

   lda #38
   jmp remain

nostatus:
   sta WSYNC
   ldy #$06
   dey
   bne nostatus+4
   sta RESP0
   nop
   lda #$07
   sta NUSIZ0
   sta NUSIZ1
   sta RESP1
   
   ldy #$00

   lda aval
   cmp #'a'
   beq loopa
   cmp #'x'
   beq loopx
   cmp #'i'
   beq loopi

loopa:
   sta WSYNC
   tya
   and #$0f
   sta COLUBK
   lda errortablea+0,y
   sta GRP0
   lda errortablea+1,y
   sta GRP1
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   lda #$00
   sta GRP0
   sta GRP1
   iny
   iny
   cpy #$20
   bne loopa
   ldy #8*10
   bne done
   
loopx:
   sta WSYNC
   tya
   and #$0f
   sta COLUBK
   lda errortablex+0,y
   sta GRP0
   lda errortablex+1,y
   sta GRP1
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   lda #$00
   sta GRP0
   sta GRP1
   iny
   iny
   cpy #$20
   bne loopx
   ldy #8*16
   bne done

loopi:
   sta WSYNC
   tya
   and #$0f
   sta COLUBK
   lda errortablei+0,y
   sta GRP0
   lda errortablei+1,y
   sta GRP1
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   lda #$00
   sta GRP0
   sta GRP1
   iny
   iny
   cpy #$20
   bne loopi
   ldy #8*17
   bne done

done:
   lda #$00
   sta WSYNC
   sta COLUBK
   sta GRP0
   sta GRP1
   
   ldx #$08
@textloop:

   lda hexgfx,y
   sta WSYNC
   sta PF1
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   sta WSYNC
   iny
   dex
   bne @textloop
   lda #$00
   sta PF1
   
   lda #22
   
remain:
   bit SWCHB
   bmi timing60hz
   clc
   adc #50
timing60hz:
   tax
@loop4:
   sta WSYNC
   dex
   bne @loop4
   
   lda SWCHB
   and #$01
   bne longjump
   jmp ($FFFE)
longjump:
   jmp vblankstart


hextosprites:
   pha
   and #$f0
   lsr
   tax
   pla
   and #$0f
   asl
   asl
   asl
   tay
   lda #$08
   sta tmp
@loop:
   sta WSYNC
   lda hexgfx,x
   sta GRP0
   lda hexgfx,y
   sta GRP1
   inx
   iny
   sta WSYNC
   dec tmp
   bne @loop
   rts

fastcheck:
   ldx #$00
   
@checkloop:
   
   lda #$00
   .byte $8b, $ff
   sta result
   
   txa
   and showbuf+0
   
   cmp result
   bne @faildetected
   inx
   bne @checkloop
@allok:
   lda #$e1
   rts
@faildetected:
   lda #$0a
   rts
